#!/usr/bin/perl
# 
# library - file 
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.01;
	# 
	# ver 0.00 [2004/04/18] 
	# ver 0.01 [2004/06/08] EUC ʳʸɤꤷ硢̤ʸХ
	require 'sbtext.pl';
	require 'sbpict.pl';
}
sub sbfile_read_entry {
	my $id = shift;
	my $file = $gEnv{dir}{data} . $gEnv{dir}{ent} . $id . $gEnv{file}{suf};
	my %num = ();
	open(ENTRYIN,"<$file") or die($gMsg{'error'}{'file_open'} . $file);
	while (my $line = <ENTRYIN>) {
		$line =~ tr/\x0D\x0A//d;
		my ($label,$tmp) = split("\t",$line,2);
		if ($label eq 'com' or $label eq 'tb') {
			$gData{'entry'}{$id}{$label} = [] if ($num{$label} == 0);
			$gData{'entry'}{$id}{$label}[$num{$label}] = {};
		}
		my $val = '';
		foreach my $key ( @{$gEnv{'entdet'}{$label}} ) {
			($val,$tmp) = split('<>',$tmp,2);
			if ($label eq 'com' or $label eq 'tb') {
				$gData{'entry'}{$id}{$label}[$num{$label}]{$key} = $val;
			} else {
				$gData{'entry'}{$id}{$label}{$key} = $val;
			}
		}
		$num{$label}++ if ($label eq 'com' or $label eq 'tb');
	}
	close(ENTRYIN);
	return();
}
sub sbfile_update_entry {
	my $id = shift;
	my $file = $gEnv{dir}{data} . $gEnv{dir}{ent} . $id . $gEnv{file}{suf};
	open(ENTRYOUT,">$file") or die($gMsg{'error'}{'file_open'} . $file);
	binmode(ENTRYOUT);
	foreach my $label ('ent','com','tb') { # ߽
		if ($label eq 'com' or $label eq 'tb') {
			for (my $i=0;$i<@{$gData{'entry'}{$id}{$label}};$i++) {
				next if ($gData{'entry'}{$id}{$label}[$i]{'id'} eq '');
				print ENTRYOUT $label,"\t";
				foreach my $key ( @{$gEnv{'entdet'}{$label}} ) {
					print ENTRYOUT $gData{'entry'}{$id}{$label}[$i]{$key},'<>';
				}
				print ENTRYOUT "\n";
			}
		} else {
			print ENTRYOUT $label,"\t";
			foreach my $key ( @{$gEnv{'entdet'}{$label}} ) {
				print ENTRYOUT $gData{'entry'}{$id}{$label}{$key},'<>';
			}
			print ENTRYOUT "\n";
		}
	}
	close(ENTRYOUT);
	chmod(0666,$file);
	return();
}
sub sbfile_update_css {
	my ($css,$file) = @_;
	$css = &sbtxt_lfconv(&sbtxt_det($css),1);
	open(CSSOUT,">$file") or die($gMsg{'error'}{'file_open'} . $file);
	binmode(CSSOUT);
	print CSSOUT $css;
	close(CSSOUT);
	return();
}
sub sbfile_read_datafile {
	my $type = shift;
	my $file = $gEnv{dir}{data} . $gEnv{file}{$type};
	open(DATAIN,"<$file") or die($gMsg{'error'}{'file_open'} . $file);
	$gData{'num'}{$type} = <DATAIN>;
	while (my $line = <DATAIN>) {
		$line =~ tr/\x0D\x0A//d;
		my ($num,$tmp) = split('<>',$line,2);
		foreach my $elem ( @{$gEnv{$type}} ) {
			($gData{$type}[$num]{$elem},$line) = split('<>',$line,2);
		}
	}
	close(DATAIN);
	$gData{'num'}{$type} =~ tr/\x0D\x0A//d;
	return();
}
sub sbfile_update_datafile {
	my $type = shift;
	my $file = $gEnv{dir}{data} . $gEnv{file}{$type};
	open(DATAOUT,">$file") or die($gMsg{'error'}{'file_open'} . $file);
	binmode(DATAOUT);
	print DATAOUT $gData{'num'}{$type},"\n";
	for (my $i=0;$i<$gData{'num'}{$type};$i++) {
		next if ($gData{$type}[$i]{'id'} eq '');
		foreach my $elem ( @{$gEnv{$type}} ) {
			print DATAOUT $gData{$type}[$i]{$elem} . '<>';
		}
		print DATAOUT "\n";
	}
	close(DATAOUT);
	return();
}
sub sbfile_read_admin_temp {
	my $file = shift;
	my $text = '';
	open(ADMINTEMP,"<$file") or die($gMsg{'error'}{'file_open'} . $file);
	while (my $line = <ADMINTEMP>) {
		$line =~ tr/\x0D\x0A//d;
		$line = &sbtxt_lfconv($line,0) . '%n';
		$text .= &sbtxt_ent($line);
	}
	close(ADMINTEMP);
	$text = &sblang_conv($text,$gEnv{'code'},'euc') if ($gEnv{'code'} ne 'euc' and $gEnv{'conf'}{'temp_conv'});
	return($text);
}
sub sbfile_update_conf {
	my $file = $gEnv{dir}{data} . $gEnv{file}{conf};
	open(CONFOUT,">$file") or die($gMsg{'error'}{'file_open'} . $file);
	foreach my $key ( keys(%{$gEnv{'conf'}}) ) {
		print CONFOUT $key,"\t",$gEnv{'conf'}{$key},"\n";
	}
	close(CONFOUT);
	return();
}
sub sbfile_upload_image { # եΥåץ
	my ($id,$name,$entity,$dir) = @_; # ϥѥ᡼
	my ($new,$old) = ();              # ϥѥ᡼
	my ($flag,$ctype,$macbin) = ();   # ѥ᡼
	foreach (@gIn) { # եμ
		if ($_ =~ /$name/) {
			$ctype  = $2 if ($_ =~ /(.*)Content-type:(.*)/i);
			$old    = $2 if ($_ =~ /(.*)filename=(.*)/i);
			$macbin = 1  if ($_ =~ /application\/x-macbinary/i);
		}
	}
	if ($macbin) { # ޥåХʥк
		my $len = substr($entity,83,4);
		$len    = unpack("%N",$len);
		$entity = substr($entity,128,$len);
	}
	$ctype =~ tr/\x0D\x0A//d;
	$old =~ tr/\"\x0D\x0A//d;
	$old =~ s/.*[:\/\\](.*)/$1/; # ե̾
	$flag = 1 if ($ctype !~ /image\/gif/i and $ctype !~ /image\/jpeg/i and $ctype !~ /image\/x-png/i);
	$flag = 0 if ($flag and ($old =~ /\.gif$/i or $old =~ /\.jpe?g$/i or $old =~ /\.png$/));
	$new = $id . '_' . $old;
	$new = $id . '_file' . &sbpict_picttail($new) if ($new =~ /[^a-zA-Z0-9_\-\.]/);
	if (!$flag) {
		my $file = $dir . $new;
		eval {
			die('file exit') if (-e $file); # ե뤬Ǥ¸ߤƤ
			open(IMGOUT,">$file") or die('failed file open'); # ե륪ץ
			binmode(STDOUT);
			binmode(IMGOUT);
			print IMGOUT $entity;
			close(IMGOUT);
			chmod(0666,$file);
		};
		return('','') if ($@);
		return($new,$old);
	} else {
		return('','');
	}
}
1;
